// $ANTLR 3.0.1 CminusTW.g 2010-04-06 00:53:04

    import java.lang.Double;
    import java.util.HashMap;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.stringtemplate.*;
import org.antlr.stringtemplate.language.*;
import java.util.HashMap;
public class CminusTW extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VARDEF", "ASSIGN", "COMPARE", "UPLUS", "UMINUS", "BLOCK", "DELIM", "VAR", "ID", "COMMA", "EQ", "PRINT", "INPUT", "IF", "LPAR", "RPAR", "ELSE", "WHILE", "LBR", "RBR", "LT", "GT", "PLUS", "MINUS", "MULT", "DIV", "POW", "DOUBLE", "PI", "E", "LETTER", "INT", "WHITESPACE", "COMMENT"
    };
    public static final int E=33;
    public static final int LT=24;
    public static final int WHILE=21;
    public static final int LETTER=34;
    public static final int RBR=23;
    public static final int UPLUS=7;
    public static final int ELSE=20;
    public static final int INPUT=16;
    public static final int WHITESPACE=36;
    public static final int UMINUS=8;
    public static final int INT=35;
    public static final int MULT=28;
    public static final int MINUS=27;
    public static final int DELIM=10;
    public static final int ID=12;
    public static final int EOF=-1;
    public static final int PRINT=15;
    public static final int LBR=22;
    public static final int IF=17;
    public static final int POW=30;
    public static final int LPAR=18;
    public static final int COMMA=13;
    public static final int BLOCK=9;
    public static final int ASSIGN=5;
    public static final int COMPARE=6;
    public static final int DOUBLE=31;
    public static final int GT=25;
    public static final int RPAR=19;
    public static final int PLUS=26;
    public static final int VAR=11;
    public static final int PI=32;
    public static final int EQ=14;
    public static final int DIV=29;
    public static final int VARDEF=4;
    public static final int COMMENT=37;

        public CminusTW(TreeNodeStream input) {
            super(input);
        }
        
    protected StringTemplateGroup templateLib =
      new StringTemplateGroup("CminusTWTemplates", AngleBracketTemplateLexer.class);

    public void setTemplateLib(StringTemplateGroup templateLib) {
      this.templateLib = templateLib;
    }
    public StringTemplateGroup getTemplateLib() {
      return templateLib;
    }
    /** allows convenient multi-value initialization:
     *  "new STAttrMap().put(...).put(...)"
     */
    public static class STAttrMap extends HashMap {
      public STAttrMap put(String attrName, Object value) {
        super.put(attrName, value);
        return this;
      }
      public STAttrMap put(String attrName, int value) {
        super.put(attrName, new Integer(value));
        return this;
      }
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "CminusTW.g"; }


        HashMap locals = new HashMap();
        int localsLimit = 4;
        int labelCount = 1;

        public String genLabel() {
            return "LL" + (labelCount++);
        }


    public static class program_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start program
    // CminusTW.g:24:1: program : statements -> program(stackLimit=10localsLimit=localsLimit+1statements=$statements.st);
    public final program_return program() throws RecognitionException {
        program_return retval = new program_return();
        retval.start = input.LT(1);

        statements_return statements1 = null;


        try {
            // CminusTW.g:25:5: ( statements -> program(stackLimit=10localsLimit=localsLimit+1statements=$statements.st))
            // CminusTW.g:25:7: statements
            {
            pushFollow(FOLLOW_statements_in_program60);
            statements1=statements();
            _fsp--;


            // TEMPLATE REWRITE
            // 25:18: -> program(stackLimit=10localsLimit=localsLimit+1statements=$statements.st)
            {
                retval.st = templateLib.getInstanceOf("program",
              new STAttrMap().put("stackLimit", 10).put("localsLimit", localsLimit+1).put("statements", statements1.st));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end program

    public static class statements_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start statements
    // CminusTW.g:28:1: statements : ( -> empty() | s1= statement s2= statements -> concat(i1=$s1.sti2=$s2.st));
    public final statements_return statements() throws RecognitionException {
        statements_return retval = new statements_return();
        retval.start = input.LT(1);

        statement_return s1 = null;

        statements_return s2 = null;


        try {
            // CminusTW.g:29:5: ( -> empty() | s1= statement s2= statements -> concat(i1=$s1.sti2=$s2.st))
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==EOF||LA1_0==UP) ) {
                alt1=1;
            }
            else if ( ((LA1_0>=VARDEF && LA1_0<=ASSIGN)||(LA1_0>=PRINT && LA1_0<=IF)||LA1_0==WHILE) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("28:1: statements : ( -> empty() | s1= statement s2= statements -> concat(i1=$s1.sti2=$s2.st));", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // CminusTW.g:29:19: 
                    {

                    // TEMPLATE REWRITE
                    // 29:19: -> empty()
                    {
                        retval.st = templateLib.getInstanceOf("empty");
                    }



                    }
                    break;
                case 2 :
                    // CminusTW.g:30:7: s1= statement s2= statements
                    {
                    pushFollow(FOLLOW_statement_in_statements112);
                    s1=statement();
                    _fsp--;

                    pushFollow(FOLLOW_statements_in_statements116);
                    s2=statements();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 31:7: -> concat(i1=$s1.sti2=$s2.st)
                    {
                        retval.st = templateLib.getInstanceOf("concat",
                      new STAttrMap().put("i1", s1.st).put("i2", s2.st));
                    }



                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end statements

    public static class statement_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start statement
    // CminusTW.g:34:1: statement : ( declaration | assignment -> {$assignment.st} | print -> {$print.st} | input -> {$input.st} | ifnt -> {$ifnt.st} | whilent -> {$whilent.st});
    public final statement_return statement() throws RecognitionException {
        statement_return retval = new statement_return();
        retval.start = input.LT(1);

        assignment_return assignment2 = null;

        print_return print3 = null;

        input_return input4 = null;

        ifnt_return ifnt5 = null;

        whilent_return whilent6 = null;


        try {
            // CminusTW.g:35:5: ( declaration | assignment -> {$assignment.st} | print -> {$print.st} | input -> {$input.st} | ifnt -> {$ifnt.st} | whilent -> {$whilent.st})
            int alt2=6;
            switch ( input.LA(1) ) {
            case VARDEF:
                {
                alt2=1;
                }
                break;
            case ASSIGN:
                {
                alt2=2;
                }
                break;
            case PRINT:
                {
                alt2=3;
                }
                break;
            case INPUT:
                {
                alt2=4;
                }
                break;
            case IF:
                {
                alt2=5;
                }
                break;
            case WHILE:
                {
                alt2=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("34:1: statement : ( declaration | assignment -> {$assignment.st} | print -> {$print.st} | input -> {$input.st} | ifnt -> {$ifnt.st} | whilent -> {$whilent.st});", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // CminusTW.g:35:7: declaration
                    {
                    pushFollow(FOLLOW_declaration_in_statement154);
                    declaration();
                    _fsp--;


                    }
                    break;
                case 2 :
                    // CminusTW.g:36:7: assignment
                    {
                    pushFollow(FOLLOW_assignment_in_statement162);
                    assignment2=assignment();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 37:7: -> {$assignment.st}
                    {
                        retval.st = assignment2.st;
                    }



                    }
                    break;
                case 3 :
                    // CminusTW.g:38:7: print
                    {
                    pushFollow(FOLLOW_print_in_statement180);
                    print3=print();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 39:7: -> {$print.st}
                    {
                        retval.st = print3.st;
                    }



                    }
                    break;
                case 4 :
                    // CminusTW.g:40:7: input
                    {
                    pushFollow(FOLLOW_input_in_statement198);
                    input4=input();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 41:7: -> {$input.st}
                    {
                        retval.st = input4.st;
                    }



                    }
                    break;
                case 5 :
                    // CminusTW.g:42:7: ifnt
                    {
                    pushFollow(FOLLOW_ifnt_in_statement216);
                    ifnt5=ifnt();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 43:7: -> {$ifnt.st}
                    {
                        retval.st = ifnt5.st;
                    }



                    }
                    break;
                case 6 :
                    // CminusTW.g:44:7: whilent
                    {
                    pushFollow(FOLLOW_whilent_in_statement234);
                    whilent6=whilent();
                    _fsp--;


                    // TEMPLATE REWRITE
                    // 45:7: -> {$whilent.st}
                    {
                        retval.st = whilent6.st;
                    }



                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end statement

    public static class declaration_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start declaration
    // CminusTW.g:48:1: declaration : ^( VARDEF ID ) ;
    public final declaration_return declaration() throws RecognitionException {
        declaration_return retval = new declaration_return();
        retval.start = input.LT(1);

        CommonTree ID7=null;

        try {
            // CminusTW.g:49:5: ( ^( VARDEF ID ) )
            // CminusTW.g:49:7: ^( VARDEF ID )
            {
            match(input,VARDEF,FOLLOW_VARDEF_in_declaration266); 

            match(input, Token.DOWN, null); 
            ID7=(CommonTree)input.LT(1);
            match(input,ID,FOLLOW_ID_in_declaration268); 

            match(input, Token.UP, null); 

                    if (!locals.containsKey(ID7.getText())) {
                        locals.put(ID7.getText(), localsLimit);
                        localsLimit += 2;
                    }
                  

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declaration

    public static class assignment_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start assignment
    // CminusTW.g:58:1: assignment : ^( ASSIGN ID expr ) -> store(id=$ID.textn=locals.get($ID.text)v=$expr.st);
    public final assignment_return assignment() throws RecognitionException {
        assignment_return retval = new assignment_return();
        retval.start = input.LT(1);

        CommonTree ID8=null;
        expr_return expr9 = null;


        try {
            // CminusTW.g:59:5: ( ^( ASSIGN ID expr ) -> store(id=$ID.textn=locals.get($ID.text)v=$expr.st))
            // CminusTW.g:59:7: ^( ASSIGN ID expr )
            {
            match(input,ASSIGN,FOLLOW_ASSIGN_in_assignment295); 

            match(input, Token.DOWN, null); 
            ID8=(CommonTree)input.LT(1);
            match(input,ID,FOLLOW_ID_in_assignment297); 
            pushFollow(FOLLOW_expr_in_assignment299);
            expr9=expr();
            _fsp--;


            match(input, Token.UP, null); 

            // TEMPLATE REWRITE
            // 60:7: -> store(id=$ID.textn=locals.get($ID.text)v=$expr.st)
            {
                retval.st = templateLib.getInstanceOf("store",
              new STAttrMap().put("id", ID8.getText()).put("n", locals.get(ID8.getText())).put("v", expr9.st));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end assignment

    public static class print_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start print
    // CminusTW.g:63:1: print : ^( PRINT expr ) -> print(v=$expr.st);
    public final print_return print() throws RecognitionException {
        print_return retval = new print_return();
        retval.start = input.LT(1);

        expr_return expr10 = null;


        try {
            // CminusTW.g:64:5: ( ^( PRINT expr ) -> print(v=$expr.st))
            // CminusTW.g:64:7: ^( PRINT expr )
            {
            match(input,PRINT,FOLLOW_PRINT_in_print343); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_expr_in_print345);
            expr10=expr();
            _fsp--;


            match(input, Token.UP, null); 

            // TEMPLATE REWRITE
            // 65:7: -> print(v=$expr.st)
            {
                retval.st = templateLib.getInstanceOf("print",
              new STAttrMap().put("v", expr10.st));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end print

    public static class input_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start input
    // CminusTW.g:68:1: input : ^( INPUT ID ) -> input(id=$ID.textn=locals.get($ID.text));
    public final input_return input() throws RecognitionException {
        input_return retval = new input_return();
        retval.start = input.LT(1);

        CommonTree ID11=null;

        try {
            // CminusTW.g:69:5: ( ^( INPUT ID ) -> input(id=$ID.textn=locals.get($ID.text)))
            // CminusTW.g:69:7: ^( INPUT ID )
            {
            match(input,INPUT,FOLLOW_INPUT_in_input379); 

            match(input, Token.DOWN, null); 
            ID11=(CommonTree)input.LT(1);
            match(input,ID,FOLLOW_ID_in_input381); 

            match(input, Token.UP, null); 

            // TEMPLATE REWRITE
            // 70:7: -> input(id=$ID.textn=locals.get($ID.text))
            {
                retval.st = templateLib.getInstanceOf("input",
              new STAttrMap().put("id", ID11.getText()).put("n", locals.get(ID11.getText())));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end input

    public static class ifnt_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start ifnt
    // CminusTW.g:73:1: ifnt : ^( IF condition b1= block b2= block ) -> if(condition=$condition.stthenBlock=$b1.stelseBlock=$b2.stlabel1=genLabel()label2=genLabel());
    public final ifnt_return ifnt() throws RecognitionException {
        ifnt_return retval = new ifnt_return();
        retval.start = input.LT(1);

        block_return b1 = null;

        block_return b2 = null;

        condition_return condition12 = null;


        try {
            // CminusTW.g:74:5: ( ^( IF condition b1= block b2= block ) -> if(condition=$condition.stthenBlock=$b1.stelseBlock=$b2.stlabel1=genLabel()label2=genLabel()))
            // CminusTW.g:74:7: ^( IF condition b1= block b2= block )
            {
            match(input,IF,FOLLOW_IF_in_ifnt420); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_condition_in_ifnt422);
            condition12=condition();
            _fsp--;

            pushFollow(FOLLOW_block_in_ifnt426);
            b1=block();
            _fsp--;

            pushFollow(FOLLOW_block_in_ifnt430);
            b2=block();
            _fsp--;


            match(input, Token.UP, null); 

            // TEMPLATE REWRITE
            // 75:7: -> if(condition=$condition.stthenBlock=$b1.stelseBlock=$b2.stlabel1=genLabel()label2=genLabel())
            {
                retval.st = templateLib.getInstanceOf("if",
              new STAttrMap().put("condition", condition12.st).put("thenBlock", b1.st).put("elseBlock", b2.st).put("label1", genLabel()).put("label2", genLabel()));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end ifnt

    public static class whilent_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start whilent
    // CminusTW.g:78:1: whilent : ^( WHILE condition b1= block ) -> while(condition=$condition.stblock=$b1.stlabel1=genLabel()label2=genLabel());
    public final whilent_return whilent() throws RecognitionException {
        whilent_return retval = new whilent_return();
        retval.start = input.LT(1);

        block_return b1 = null;

        condition_return condition13 = null;


        try {
            // CminusTW.g:79:5: ( ^( WHILE condition b1= block ) -> while(condition=$condition.stblock=$b1.stlabel1=genLabel()label2=genLabel()))
            // CminusTW.g:79:7: ^( WHILE condition b1= block )
            {
            match(input,WHILE,FOLLOW_WHILE_in_whilent484); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_condition_in_whilent486);
            condition13=condition();
            _fsp--;

            pushFollow(FOLLOW_block_in_whilent490);
            b1=block();
            _fsp--;


            match(input, Token.UP, null); 

            // TEMPLATE REWRITE
            // 80:7: -> while(condition=$condition.stblock=$b1.stlabel1=genLabel()label2=genLabel())
            {
                retval.st = templateLib.getInstanceOf("while",
              new STAttrMap().put("condition", condition13.st).put("block", b1.st).put("label1", genLabel()).put("label2", genLabel()));
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end whilent

    public static class condition_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start condition
    // CminusTW.g:83:1: condition : ( ^( LT e1= expr e2= expr ) -> lt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( GT e1= expr e2= expr ) -> gt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( EQ e1= expr e2= expr ) -> eq(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()));
    public final condition_return condition() throws RecognitionException {
        condition_return retval = new condition_return();
        retval.start = input.LT(1);

        expr_return e1 = null;

        expr_return e2 = null;


        try {
            // CminusTW.g:84:5: ( ^( LT e1= expr e2= expr ) -> lt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( GT e1= expr e2= expr ) -> gt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( EQ e1= expr e2= expr ) -> eq(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()))
            int alt3=3;
            switch ( input.LA(1) ) {
            case LT:
                {
                alt3=1;
                }
                break;
            case GT:
                {
                alt3=2;
                }
                break;
            case EQ:
                {
                alt3=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("83:1: condition : ( ^( LT e1= expr e2= expr ) -> lt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( GT e1= expr e2= expr ) -> gt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()) | ^( EQ e1= expr e2= expr ) -> eq(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel()));", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // CminusTW.g:84:7: ^( LT e1= expr e2= expr )
                    {
                    match(input,LT,FOLLOW_LT_in_condition539); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_condition543);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_condition547);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 85:7: -> lt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel())
                    {
                        retval.st = templateLib.getInstanceOf("lt",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st).put("label1", genLabel()).put("label2", genLabel()));
                    }



                    }
                    break;
                case 2 :
                    // CminusTW.g:86:7: ^( GT e1= expr e2= expr )
                    {
                    match(input,GT,FOLLOW_GT_in_condition587); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_condition591);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_condition595);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 87:7: -> gt(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel())
                    {
                        retval.st = templateLib.getInstanceOf("gt",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st).put("label1", genLabel()).put("label2", genLabel()));
                    }



                    }
                    break;
                case 3 :
                    // CminusTW.g:88:7: ^( EQ e1= expr e2= expr )
                    {
                    match(input,EQ,FOLLOW_EQ_in_condition635); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_condition639);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_condition643);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 89:7: -> eq(e1=$e1.ste2=$e2.stlabel1=genLabel()label2=genLabel())
                    {
                        retval.st = templateLib.getInstanceOf("eq",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st).put("label1", genLabel()).put("label2", genLabel()));
                    }



                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end condition

    public static class block_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start block
    // CminusTW.g:92:1: block : ^( BLOCK statements ) -> {$statements.st};
    public final block_return block() throws RecognitionException {
        block_return retval = new block_return();
        retval.start = input.LT(1);

        statements_return statements14 = null;


        try {
            // CminusTW.g:93:5: ( ^( BLOCK statements ) -> {$statements.st})
            // CminusTW.g:93:7: ^( BLOCK statements )
            {
            match(input,BLOCK,FOLLOW_BLOCK_in_block692); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_statements_in_block694);
                statements14=statements();
                _fsp--;


                match(input, Token.UP, null); 
            }

            // TEMPLATE REWRITE
            // 94:7: -> {$statements.st}
            {
                retval.st = statements14.st;
            }



            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end block

    public static class expr_return extends TreeRuleReturnScope {
        public StringTemplate st;
        public Object getTemplate() { return st; }
        public String toString() { return st==null?null:st.toString(); }
    };

    // $ANTLR start expr
    // CminusTW.g:97:1: expr : ( ^( UPLUS e1= expr ) -> uplus(e1=$e1.st) | ^( UMINUS e1= expr ) -> uminus(e1=$e1.st) | ^( PLUS e1= expr e2= expr ) -> add(e1=$e1.ste2=$e2.st) | ^( MINUS e1= expr e2= expr ) -> sub(e1=$e1.ste2=$e2.st) | ^( MULT e1= expr e2= expr ) -> mul(e1=$e1.ste2=$e2.st) | ^( DIV e1= expr e2= expr ) -> div(e1=$e1.ste2=$e2.st) | ^( POW e1= expr e2= expr ) -> pow(e1=$e1.ste2=$e2.st) | DOUBLE -> push(const=Double.parseDouble($DOUBLE.text)) | PI -> push(const=\"3.14159265358979323846\") | E -> push(const=\"2.71828182845904523536\") | ID -> load(id=$ID.textn=locals.get($ID.text)));
    public final expr_return expr() throws RecognitionException {
        expr_return retval = new expr_return();
        retval.start = input.LT(1);

        CommonTree DOUBLE15=null;
        CommonTree ID16=null;
        expr_return e1 = null;

        expr_return e2 = null;


        try {
            // CminusTW.g:98:5: ( ^( UPLUS e1= expr ) -> uplus(e1=$e1.st) | ^( UMINUS e1= expr ) -> uminus(e1=$e1.st) | ^( PLUS e1= expr e2= expr ) -> add(e1=$e1.ste2=$e2.st) | ^( MINUS e1= expr e2= expr ) -> sub(e1=$e1.ste2=$e2.st) | ^( MULT e1= expr e2= expr ) -> mul(e1=$e1.ste2=$e2.st) | ^( DIV e1= expr e2= expr ) -> div(e1=$e1.ste2=$e2.st) | ^( POW e1= expr e2= expr ) -> pow(e1=$e1.ste2=$e2.st) | DOUBLE -> push(const=Double.parseDouble($DOUBLE.text)) | PI -> push(const=\"3.14159265358979323846\") | E -> push(const=\"2.71828182845904523536\") | ID -> load(id=$ID.textn=locals.get($ID.text)))
            int alt4=11;
            switch ( input.LA(1) ) {
            case UPLUS:
                {
                alt4=1;
                }
                break;
            case UMINUS:
                {
                alt4=2;
                }
                break;
            case PLUS:
                {
                alt4=3;
                }
                break;
            case MINUS:
                {
                alt4=4;
                }
                break;
            case MULT:
                {
                alt4=5;
                }
                break;
            case DIV:
                {
                alt4=6;
                }
                break;
            case POW:
                {
                alt4=7;
                }
                break;
            case DOUBLE:
                {
                alt4=8;
                }
                break;
            case PI:
                {
                alt4=9;
                }
                break;
            case E:
                {
                alt4=10;
                }
                break;
            case ID:
                {
                alt4=11;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("97:1: expr : ( ^( UPLUS e1= expr ) -> uplus(e1=$e1.st) | ^( UMINUS e1= expr ) -> uminus(e1=$e1.st) | ^( PLUS e1= expr e2= expr ) -> add(e1=$e1.ste2=$e2.st) | ^( MINUS e1= expr e2= expr ) -> sub(e1=$e1.ste2=$e2.st) | ^( MULT e1= expr e2= expr ) -> mul(e1=$e1.ste2=$e2.st) | ^( DIV e1= expr e2= expr ) -> div(e1=$e1.ste2=$e2.st) | ^( POW e1= expr e2= expr ) -> pow(e1=$e1.ste2=$e2.st) | DOUBLE -> push(const=Double.parseDouble($DOUBLE.text)) | PI -> push(const=\"3.14159265358979323846\") | E -> push(const=\"2.71828182845904523536\") | ID -> load(id=$ID.textn=locals.get($ID.text)));", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // CminusTW.g:98:7: ^( UPLUS e1= expr )
                    {
                    match(input,UPLUS,FOLLOW_UPLUS_in_expr723); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr727);
                    e1=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 99:7: -> uplus(e1=$e1.st)
                    {
                        retval.st = templateLib.getInstanceOf("uplus",
                      new STAttrMap().put("e1", e1.st));
                    }



                    }
                    break;
                case 2 :
                    // CminusTW.g:100:7: ^( UMINUS e1= expr )
                    {
                    match(input,UMINUS,FOLLOW_UMINUS_in_expr760); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr764);
                    e1=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 101:7: -> uminus(e1=$e1.st)
                    {
                        retval.st = templateLib.getInstanceOf("uminus",
                      new STAttrMap().put("e1", e1.st));
                    }



                    }
                    break;
                case 3 :
                    // CminusTW.g:102:7: ^( PLUS e1= expr e2= expr )
                    {
                    match(input,PLUS,FOLLOW_PLUS_in_expr790); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr794);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr798);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 103:7: -> add(e1=$e1.ste2=$e2.st)
                    {
                        retval.st = templateLib.getInstanceOf("add",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st));
                    }



                    }
                    break;
                case 4 :
                    // CminusTW.g:104:7: ^( MINUS e1= expr e2= expr )
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_expr828); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr832);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr836);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 105:7: -> sub(e1=$e1.ste2=$e2.st)
                    {
                        retval.st = templateLib.getInstanceOf("sub",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st));
                    }



                    }
                    break;
                case 5 :
                    // CminusTW.g:106:7: ^( MULT e1= expr e2= expr )
                    {
                    match(input,MULT,FOLLOW_MULT_in_expr866); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr870);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr874);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 107:7: -> mul(e1=$e1.ste2=$e2.st)
                    {
                        retval.st = templateLib.getInstanceOf("mul",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st));
                    }



                    }
                    break;
                case 6 :
                    // CminusTW.g:108:7: ^( DIV e1= expr e2= expr )
                    {
                    match(input,DIV,FOLLOW_DIV_in_expr904); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr908);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr912);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 109:7: -> div(e1=$e1.ste2=$e2.st)
                    {
                        retval.st = templateLib.getInstanceOf("div",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st));
                    }



                    }
                    break;
                case 7 :
                    // CminusTW.g:110:7: ^( POW e1= expr e2= expr )
                    {
                    match(input,POW,FOLLOW_POW_in_expr942); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr946);
                    e1=expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr950);
                    e2=expr();
                    _fsp--;


                    match(input, Token.UP, null); 

                    // TEMPLATE REWRITE
                    // 111:7: -> pow(e1=$e1.ste2=$e2.st)
                    {
                        retval.st = templateLib.getInstanceOf("pow",
                      new STAttrMap().put("e1", e1.st).put("e2", e2.st));
                    }



                    }
                    break;
                case 8 :
                    // CminusTW.g:112:7: DOUBLE
                    {
                    DOUBLE15=(CommonTree)input.LT(1);
                    match(input,DOUBLE,FOLLOW_DOUBLE_in_expr979); 

                    // TEMPLATE REWRITE
                    // 113:7: -> push(const=Double.parseDouble($DOUBLE.text))
                    {
                        retval.st = templateLib.getInstanceOf("push",
                      new STAttrMap().put("const", Double.parseDouble(DOUBLE15.getText())));
                    }



                    }
                    break;
                case 9 :
                    // CminusTW.g:114:7: PI
                    {
                    match(input,PI,FOLLOW_PI_in_expr1002); 

                    // TEMPLATE REWRITE
                    // 115:7: -> push(const=\"3.14159265358979323846\")
                    {
                        retval.st = templateLib.getInstanceOf("push",
                      new STAttrMap().put("const", "3.14159265358979323846"));
                    }



                    }
                    break;
                case 10 :
                    // CminusTW.g:116:7: E
                    {
                    match(input,E,FOLLOW_E_in_expr1025); 

                    // TEMPLATE REWRITE
                    // 117:7: -> push(const=\"2.71828182845904523536\")
                    {
                        retval.st = templateLib.getInstanceOf("push",
                      new STAttrMap().put("const", "2.71828182845904523536"));
                    }



                    }
                    break;
                case 11 :
                    // CminusTW.g:118:7: ID
                    {
                    ID16=(CommonTree)input.LT(1);
                    match(input,ID,FOLLOW_ID_in_expr1048); 

                    // TEMPLATE REWRITE
                    // 119:7: -> load(id=$ID.textn=locals.get($ID.text))
                    {
                        retval.st = templateLib.getInstanceOf("load",
                      new STAttrMap().put("id", ID16.getText()).put("n", locals.get(ID16.getText())));
                    }



                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end expr


 

    public static final BitSet FOLLOW_statements_in_program60 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_statements112 = new BitSet(new long[]{0x0000000000238030L});
    public static final BitSet FOLLOW_statements_in_statements116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_statement154 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assignment_in_statement162 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_print_in_statement180 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_input_in_statement198 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifnt_in_statement216 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_whilent_in_statement234 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VARDEF_in_declaration266 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_declaration268 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ASSIGN_in_assignment295 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_assignment297 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_assignment299 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PRINT_in_print343 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_print345 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_INPUT_in_input379 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_input381 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IF_in_ifnt420 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_ifnt422 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_block_in_ifnt426 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_block_in_ifnt430 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_WHILE_in_whilent484 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_whilent486 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_block_in_whilent490 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_LT_in_condition539 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_condition543 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_condition547 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_GT_in_condition587 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_condition591 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_condition595 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_EQ_in_condition635 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_condition639 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_condition643 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_BLOCK_in_block692 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_statements_in_block694 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UPLUS_in_expr723 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr727 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UMINUS_in_expr760 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr764 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PLUS_in_expr790 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr794 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_expr798 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MINUS_in_expr828 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr832 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_expr836 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MULT_in_expr866 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr870 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_expr874 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DIV_in_expr904 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr908 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_expr912 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_POW_in_expr942 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr946 = new BitSet(new long[]{0x00000003FC001180L});
    public static final BitSet FOLLOW_expr_in_expr950 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOUBLE_in_expr979 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PI_in_expr1002 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_E_in_expr1025 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_expr1048 = new BitSet(new long[]{0x0000000000000002L});

}