// $ANTLR 3.0.1 Cminus.g 2010-04-06 00:53:03

import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class CminusParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VARDEF", "ASSIGN", "COMPARE", "UPLUS", "UMINUS", "BLOCK", "DELIM", "VAR", "ID", "COMMA", "EQ", "PRINT", "INPUT", "IF", "LPAR", "RPAR", "ELSE", "WHILE", "LBR", "RBR", "LT", "GT", "PLUS", "MINUS", "MULT", "DIV", "POW", "DOUBLE", "PI", "E", "LETTER", "INT", "WHITESPACE", "COMMENT"
    };
    public static final int E=33;
    public static final int LT=24;
    public static final int WHILE=21;
    public static final int LETTER=34;
    public static final int RBR=23;
    public static final int UPLUS=7;
    public static final int ELSE=20;
    public static final int INPUT=16;
    public static final int WHITESPACE=36;
    public static final int UMINUS=8;
    public static final int INT=35;
    public static final int MULT=28;
    public static final int MINUS=27;
    public static final int DELIM=10;
    public static final int ID=12;
    public static final int EOF=-1;
    public static final int PRINT=15;
    public static final int LBR=22;
    public static final int IF=17;
    public static final int POW=30;
    public static final int LPAR=18;
    public static final int COMMA=13;
    public static final int BLOCK=9;
    public static final int ASSIGN=5;
    public static final int COMPARE=6;
    public static final int DOUBLE=31;
    public static final int GT=25;
    public static final int PLUS=26;
    public static final int RPAR=19;
    public static final int VAR=11;
    public static final int PI=32;
    public static final int DIV=29;
    public static final int EQ=14;
    public static final int COMMENT=37;
    public static final int VARDEF=4;

        public CminusParser(TokenStream input) {
            super(input);
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "Cminus.g"; }


    public static class program_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start program
    // Cminus.g:16:1: program : statements EOF ;
    public final program_return program() throws RecognitionException {
        program_return retval = new program_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EOF2=null;
        statements_return statements1 = null;


        Object EOF2_tree=null;

        try {
            // Cminus.g:17:5: ( statements EOF )
            // Cminus.g:17:7: statements EOF
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_statements_in_program77);
            statements1=statements();
            _fsp--;

            adaptor.addChild(root_0, statements1.getTree());
            EOF2=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_program79); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end program

    public static class statements_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start statements
    // Cminus.g:20:1: statements : ( statement )+ ;
    public final statements_return statements() throws RecognitionException {
        statements_return retval = new statements_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        statement_return statement3 = null;



        try {
            // Cminus.g:21:5: ( ( statement )+ )
            // Cminus.g:21:7: ( statement )+
            {
            root_0 = (Object)adaptor.nil();

            // Cminus.g:21:7: ( statement )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=VAR && LA1_0<=ID)||(LA1_0>=PRINT && LA1_0<=IF)||LA1_0==WHILE) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // Cminus.g:21:8: statement
            	    {
            	    pushFollow(FOLLOW_statement_in_statements102);
            	    statement3=statement();
            	    _fsp--;

            	    adaptor.addChild(root_0, statement3.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end statements

    public static class statement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start statement
    // Cminus.g:24:1: statement : ( declaration DELIM | assingment DELIM | print DELIM | input DELIM | ifnt | whilent );
    public final statement_return statement() throws RecognitionException {
        statement_return retval = new statement_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token DELIM5=null;
        Token DELIM7=null;
        Token DELIM9=null;
        Token DELIM11=null;
        declaration_return declaration4 = null;

        assingment_return assingment6 = null;

        print_return print8 = null;

        input_return input10 = null;

        ifnt_return ifnt12 = null;

        whilent_return whilent13 = null;


        Object DELIM5_tree=null;
        Object DELIM7_tree=null;
        Object DELIM9_tree=null;
        Object DELIM11_tree=null;

        try {
            // Cminus.g:25:5: ( declaration DELIM | assingment DELIM | print DELIM | input DELIM | ifnt | whilent )
            int alt2=6;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt2=1;
                }
                break;
            case ID:
                {
                alt2=2;
                }
                break;
            case PRINT:
                {
                alt2=3;
                }
                break;
            case INPUT:
                {
                alt2=4;
                }
                break;
            case IF:
                {
                alt2=5;
                }
                break;
            case WHILE:
                {
                alt2=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("24:1: statement : ( declaration DELIM | assingment DELIM | print DELIM | input DELIM | ifnt | whilent );", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // Cminus.g:25:7: declaration DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_declaration_in_statement121);
                    declaration4=declaration();
                    _fsp--;

                    adaptor.addChild(root_0, declaration4.getTree());
                    DELIM5=(Token)input.LT(1);
                    match(input,DELIM,FOLLOW_DELIM_in_statement123); 

                    }
                    break;
                case 2 :
                    // Cminus.g:26:7: assingment DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_assingment_in_statement132);
                    assingment6=assingment();
                    _fsp--;

                    adaptor.addChild(root_0, assingment6.getTree());
                    DELIM7=(Token)input.LT(1);
                    match(input,DELIM,FOLLOW_DELIM_in_statement134); 

                    }
                    break;
                case 3 :
                    // Cminus.g:27:7: print DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_print_in_statement143);
                    print8=print();
                    _fsp--;

                    adaptor.addChild(root_0, print8.getTree());
                    DELIM9=(Token)input.LT(1);
                    match(input,DELIM,FOLLOW_DELIM_in_statement145); 

                    }
                    break;
                case 4 :
                    // Cminus.g:28:7: input DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_input_in_statement154);
                    input10=input();
                    _fsp--;

                    adaptor.addChild(root_0, input10.getTree());
                    DELIM11=(Token)input.LT(1);
                    match(input,DELIM,FOLLOW_DELIM_in_statement156); 

                    }
                    break;
                case 5 :
                    // Cminus.g:29:7: ifnt
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_ifnt_in_statement165);
                    ifnt12=ifnt();
                    _fsp--;

                    adaptor.addChild(root_0, ifnt12.getTree());

                    }
                    break;
                case 6 :
                    // Cminus.g:30:7: whilent
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_whilent_in_statement173);
                    whilent13=whilent();
                    _fsp--;

                    adaptor.addChild(root_0, whilent13.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end statement

    public static class declaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start declaration
    // Cminus.g:33:1: declaration : VAR ID ( COMMA ID )* -> ( ^( VARDEF ID ) )+ ;
    public final declaration_return declaration() throws RecognitionException {
        declaration_return retval = new declaration_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token VAR14=null;
        Token ID15=null;
        Token COMMA16=null;
        Token ID17=null;

        Object VAR14_tree=null;
        Object ID15_tree=null;
        Object COMMA16_tree=null;
        Object ID17_tree=null;
        RewriteRuleTokenStream stream_VAR=new RewriteRuleTokenStream(adaptor,"token VAR");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");

        try {
            // Cminus.g:34:5: ( VAR ID ( COMMA ID )* -> ( ^( VARDEF ID ) )+ )
            // Cminus.g:34:7: VAR ID ( COMMA ID )*
            {
            VAR14=(Token)input.LT(1);
            match(input,VAR,FOLLOW_VAR_in_declaration190); 
            stream_VAR.add(VAR14);

            ID15=(Token)input.LT(1);
            match(input,ID,FOLLOW_ID_in_declaration192); 
            stream_ID.add(ID15);

            // Cminus.g:34:14: ( COMMA ID )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==COMMA) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // Cminus.g:34:15: COMMA ID
            	    {
            	    COMMA16=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_declaration195); 
            	    stream_COMMA.add(COMMA16);

            	    ID17=(Token)input.LT(1);
            	    match(input,ID,FOLLOW_ID_in_declaration197); 
            	    stream_ID.add(ID17);


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            // AST REWRITE
            // elements: ID
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 34:26: -> ( ^( VARDEF ID ) )+
            {
                if ( !(stream_ID.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_ID.hasNext() ) {
                    // Cminus.g:34:29: ^( VARDEF ID )
                    {
                    Object root_1 = (Object)adaptor.nil();
                    root_1 = (Object)adaptor.becomeRoot(adaptor.create(VARDEF, "VARDEF"), root_1);

                    adaptor.addChild(root_1, stream_ID.next());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_ID.reset();

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end declaration

    public static class assingment_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start assingment
    // Cminus.g:37:1: assingment : ID EQ expr -> ^( ASSIGN ID expr ) ;
    public final assingment_return assingment() throws RecognitionException {
        assingment_return retval = new assingment_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ID18=null;
        Token EQ19=null;
        expr_return expr20 = null;


        Object ID18_tree=null;
        Object EQ19_tree=null;
        RewriteRuleTokenStream stream_EQ=new RewriteRuleTokenStream(adaptor,"token EQ");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // Cminus.g:38:5: ( ID EQ expr -> ^( ASSIGN ID expr ) )
            // Cminus.g:38:7: ID EQ expr
            {
            ID18=(Token)input.LT(1);
            match(input,ID,FOLLOW_ID_in_assingment225); 
            stream_ID.add(ID18);

            EQ19=(Token)input.LT(1);
            match(input,EQ,FOLLOW_EQ_in_assingment227); 
            stream_EQ.add(EQ19);

            pushFollow(FOLLOW_expr_in_assingment229);
            expr20=expr();
            _fsp--;

            stream_expr.add(expr20.getTree());

            // AST REWRITE
            // elements: ID, expr
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 38:18: -> ^( ASSIGN ID expr )
            {
                // Cminus.g:38:21: ^( ASSIGN ID expr )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(adaptor.create(ASSIGN, "ASSIGN"), root_1);

                adaptor.addChild(root_1, stream_ID.next());
                adaptor.addChild(root_1, stream_expr.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end assingment

    public static class print_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start print
    // Cminus.g:41:1: print : PRINT expr ;
    public final print_return print() throws RecognitionException {
        print_return retval = new print_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token PRINT21=null;
        expr_return expr22 = null;


        Object PRINT21_tree=null;

        try {
            // Cminus.g:42:5: ( PRINT expr )
            // Cminus.g:42:7: PRINT expr
            {
            root_0 = (Object)adaptor.nil();

            PRINT21=(Token)input.LT(1);
            match(input,PRINT,FOLLOW_PRINT_in_print256); 
            PRINT21_tree = (Object)adaptor.create(PRINT21);
            root_0 = (Object)adaptor.becomeRoot(PRINT21_tree, root_0);

            pushFollow(FOLLOW_expr_in_print259);
            expr22=expr();
            _fsp--;

            adaptor.addChild(root_0, expr22.getTree());

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end print

    public static class input_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start input
    // Cminus.g:45:1: input : INPUT ID ;
    public final input_return input() throws RecognitionException {
        input_return retval = new input_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token INPUT23=null;
        Token ID24=null;

        Object INPUT23_tree=null;
        Object ID24_tree=null;

        try {
            // Cminus.g:46:5: ( INPUT ID )
            // Cminus.g:46:7: INPUT ID
            {
            root_0 = (Object)adaptor.nil();

            INPUT23=(Token)input.LT(1);
            match(input,INPUT,FOLLOW_INPUT_in_input276); 
            INPUT23_tree = (Object)adaptor.create(INPUT23);
            root_0 = (Object)adaptor.becomeRoot(INPUT23_tree, root_0);

            ID24=(Token)input.LT(1);
            match(input,ID,FOLLOW_ID_in_input279); 
            ID24_tree = (Object)adaptor.create(ID24);
            adaptor.addChild(root_0, ID24_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end input

    public static class ifnt_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start ifnt
    // Cminus.g:49:1: ifnt : IF LPAR condition RPAR block ( ELSE block )? ;
    public final ifnt_return ifnt() throws RecognitionException {
        ifnt_return retval = new ifnt_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IF25=null;
        Token LPAR26=null;
        Token RPAR28=null;
        Token ELSE30=null;
        condition_return condition27 = null;

        block_return block29 = null;

        block_return block31 = null;


        Object IF25_tree=null;
        Object LPAR26_tree=null;
        Object RPAR28_tree=null;
        Object ELSE30_tree=null;

        try {
            // Cminus.g:50:5: ( IF LPAR condition RPAR block ( ELSE block )? )
            // Cminus.g:50:7: IF LPAR condition RPAR block ( ELSE block )?
            {
            root_0 = (Object)adaptor.nil();

            IF25=(Token)input.LT(1);
            match(input,IF,FOLLOW_IF_in_ifnt296); 
            IF25_tree = (Object)adaptor.create(IF25);
            root_0 = (Object)adaptor.becomeRoot(IF25_tree, root_0);

            LPAR26=(Token)input.LT(1);
            match(input,LPAR,FOLLOW_LPAR_in_ifnt299); 
            pushFollow(FOLLOW_condition_in_ifnt302);
            condition27=condition();
            _fsp--;

            adaptor.addChild(root_0, condition27.getTree());
            RPAR28=(Token)input.LT(1);
            match(input,RPAR,FOLLOW_RPAR_in_ifnt304); 
            pushFollow(FOLLOW_block_in_ifnt307);
            block29=block();
            _fsp--;

            adaptor.addChild(root_0, block29.getTree());
            // Cminus.g:50:39: ( ELSE block )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==ELSE) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // Cminus.g:50:40: ELSE block
                    {
                    ELSE30=(Token)input.LT(1);
                    match(input,ELSE,FOLLOW_ELSE_in_ifnt310); 
                    pushFollow(FOLLOW_block_in_ifnt313);
                    block31=block();
                    _fsp--;

                    adaptor.addChild(root_0, block31.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end ifnt

    public static class whilent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start whilent
    // Cminus.g:53:1: whilent : WHILE LPAR condition RPAR block ;
    public final whilent_return whilent() throws RecognitionException {
        whilent_return retval = new whilent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token WHILE32=null;
        Token LPAR33=null;
        Token RPAR35=null;
        condition_return condition34 = null;

        block_return block36 = null;


        Object WHILE32_tree=null;
        Object LPAR33_tree=null;
        Object RPAR35_tree=null;

        try {
            // Cminus.g:54:5: ( WHILE LPAR condition RPAR block )
            // Cminus.g:54:7: WHILE LPAR condition RPAR block
            {
            root_0 = (Object)adaptor.nil();

            WHILE32=(Token)input.LT(1);
            match(input,WHILE,FOLLOW_WHILE_in_whilent332); 
            WHILE32_tree = (Object)adaptor.create(WHILE32);
            root_0 = (Object)adaptor.becomeRoot(WHILE32_tree, root_0);

            LPAR33=(Token)input.LT(1);
            match(input,LPAR,FOLLOW_LPAR_in_whilent335); 
            pushFollow(FOLLOW_condition_in_whilent338);
            condition34=condition();
            _fsp--;

            adaptor.addChild(root_0, condition34.getTree());
            RPAR35=(Token)input.LT(1);
            match(input,RPAR,FOLLOW_RPAR_in_whilent340); 
            pushFollow(FOLLOW_block_in_whilent343);
            block36=block();
            _fsp--;

            adaptor.addChild(root_0, block36.getTree());

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end whilent

    public static class block_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start block
    // Cminus.g:57:1: block : LBR statements RBR -> ^( BLOCK statements ) ;
    public final block_return block() throws RecognitionException {
        block_return retval = new block_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBR37=null;
        Token RBR39=null;
        statements_return statements38 = null;


        Object LBR37_tree=null;
        Object RBR39_tree=null;
        RewriteRuleTokenStream stream_RBR=new RewriteRuleTokenStream(adaptor,"token RBR");
        RewriteRuleTokenStream stream_LBR=new RewriteRuleTokenStream(adaptor,"token LBR");
        RewriteRuleSubtreeStream stream_statements=new RewriteRuleSubtreeStream(adaptor,"rule statements");
        try {
            // Cminus.g:58:5: ( LBR statements RBR -> ^( BLOCK statements ) )
            // Cminus.g:58:7: LBR statements RBR
            {
            LBR37=(Token)input.LT(1);
            match(input,LBR,FOLLOW_LBR_in_block360); 
            stream_LBR.add(LBR37);

            pushFollow(FOLLOW_statements_in_block362);
            statements38=statements();
            _fsp--;

            stream_statements.add(statements38.getTree());
            RBR39=(Token)input.LT(1);
            match(input,RBR,FOLLOW_RBR_in_block364); 
            stream_RBR.add(RBR39);


            // AST REWRITE
            // elements: statements
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 58:26: -> ^( BLOCK statements )
            {
                // Cminus.g:58:29: ^( BLOCK statements )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(adaptor.create(BLOCK, "BLOCK"), root_1);

                adaptor.addChild(root_1, stream_statements.next());

                adaptor.addChild(root_0, root_1);
                }

            }



            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end block

    public static class condition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start condition
    // Cminus.g:61:1: condition : expr ( LT | EQ | GT ) expr ;
    public final condition_return condition() throws RecognitionException {
        condition_return retval = new condition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set41=null;
        expr_return expr40 = null;

        expr_return expr42 = null;


        Object set41_tree=null;

        try {
            // Cminus.g:62:5: ( expr ( LT | EQ | GT ) expr )
            // Cminus.g:62:7: expr ( LT | EQ | GT ) expr
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_expr_in_condition389);
            expr40=expr();
            _fsp--;

            adaptor.addChild(root_0, expr40.getTree());
            set41=(Token)input.LT(1);
            if ( input.LA(1)==EQ||(input.LA(1)>=LT && input.LA(1)<=GT) ) {
                input.consume();
                root_0 = (Object)adaptor.becomeRoot(adaptor.create(set41), root_0);
                errorRecovery=false;
            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_condition391);    throw mse;
            }

            pushFollow(FOLLOW_expr_in_condition404);
            expr42=expr();
            _fsp--;

            adaptor.addChild(root_0, expr42.getTree());

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end condition

    public static class expr_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start expr
    // Cminus.g:65:1: expr : t1= term ( PLUS t2= term | MINUS t2= term )* ;
    public final expr_return expr() throws RecognitionException {
        expr_return retval = new expr_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token PLUS43=null;
        Token MINUS44=null;
        term_return t1 = null;

        term_return t2 = null;


        Object PLUS43_tree=null;
        Object MINUS44_tree=null;

        try {
            // Cminus.g:66:5: (t1= term ( PLUS t2= term | MINUS t2= term )* )
            // Cminus.g:66:7: t1= term ( PLUS t2= term | MINUS t2= term )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_term_in_expr423);
            t1=term();
            _fsp--;

            adaptor.addChild(root_0, t1.getTree());
            // Cminus.g:66:15: ( PLUS t2= term | MINUS t2= term )*
            loop5:
            do {
                int alt5=3;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==PLUS) ) {
                    alt5=1;
                }
                else if ( (LA5_0==MINUS) ) {
                    alt5=2;
                }


                switch (alt5) {
            	case 1 :
            	    // Cminus.g:66:16: PLUS t2= term
            	    {
            	    PLUS43=(Token)input.LT(1);
            	    match(input,PLUS,FOLLOW_PLUS_in_expr426); 
            	    PLUS43_tree = (Object)adaptor.create(PLUS43);
            	    root_0 = (Object)adaptor.becomeRoot(PLUS43_tree, root_0);

            	    pushFollow(FOLLOW_term_in_expr431);
            	    t2=term();
            	    _fsp--;

            	    adaptor.addChild(root_0, t2.getTree());

            	    }
            	    break;
            	case 2 :
            	    // Cminus.g:66:32: MINUS t2= term
            	    {
            	    MINUS44=(Token)input.LT(1);
            	    match(input,MINUS,FOLLOW_MINUS_in_expr435); 
            	    MINUS44_tree = (Object)adaptor.create(MINUS44);
            	    root_0 = (Object)adaptor.becomeRoot(MINUS44_tree, root_0);

            	    pushFollow(FOLLOW_term_in_expr440);
            	    t2=term();
            	    _fsp--;

            	    adaptor.addChild(root_0, t2.getTree());

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end expr

    public static class term_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start term
    // Cminus.g:69:1: term : f1= factor ( MULT f2= factor | DIV f2= factor )* ;
    public final term_return term() throws RecognitionException {
        term_return retval = new term_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token MULT45=null;
        Token DIV46=null;
        factor_return f1 = null;

        factor_return f2 = null;


        Object MULT45_tree=null;
        Object DIV46_tree=null;

        try {
            // Cminus.g:70:5: (f1= factor ( MULT f2= factor | DIV f2= factor )* )
            // Cminus.g:70:7: f1= factor ( MULT f2= factor | DIV f2= factor )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_factor_in_term461);
            f1=factor();
            _fsp--;

            adaptor.addChild(root_0, f1.getTree());
            // Cminus.g:70:17: ( MULT f2= factor | DIV f2= factor )*
            loop6:
            do {
                int alt6=3;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==MULT) ) {
                    alt6=1;
                }
                else if ( (LA6_0==DIV) ) {
                    alt6=2;
                }


                switch (alt6) {
            	case 1 :
            	    // Cminus.g:70:18: MULT f2= factor
            	    {
            	    MULT45=(Token)input.LT(1);
            	    match(input,MULT,FOLLOW_MULT_in_term464); 
            	    MULT45_tree = (Object)adaptor.create(MULT45);
            	    root_0 = (Object)adaptor.becomeRoot(MULT45_tree, root_0);

            	    pushFollow(FOLLOW_factor_in_term469);
            	    f2=factor();
            	    _fsp--;

            	    adaptor.addChild(root_0, f2.getTree());

            	    }
            	    break;
            	case 2 :
            	    // Cminus.g:70:36: DIV f2= factor
            	    {
            	    DIV46=(Token)input.LT(1);
            	    match(input,DIV,FOLLOW_DIV_in_term473); 
            	    DIV46_tree = (Object)adaptor.create(DIV46);
            	    root_0 = (Object)adaptor.becomeRoot(DIV46_tree, root_0);

            	    pushFollow(FOLLOW_factor_in_term478);
            	    f2=factor();
            	    _fsp--;

            	    adaptor.addChild(root_0, f2.getTree());

            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end term

    public static class factor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start factor
    // Cminus.g:73:1: factor : ( PLUS factor -> ^( UPLUS factor ) | MINUS factor -> ^( UMINUS factor ) | power );
    public final factor_return factor() throws RecognitionException {
        factor_return retval = new factor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token PLUS47=null;
        Token MINUS49=null;
        factor_return factor48 = null;

        factor_return factor50 = null;

        power_return power51 = null;


        Object PLUS47_tree=null;
        Object MINUS49_tree=null;
        RewriteRuleTokenStream stream_PLUS=new RewriteRuleTokenStream(adaptor,"token PLUS");
        RewriteRuleTokenStream stream_MINUS=new RewriteRuleTokenStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_factor=new RewriteRuleSubtreeStream(adaptor,"rule factor");
        try {
            // Cminus.g:74:5: ( PLUS factor -> ^( UPLUS factor ) | MINUS factor -> ^( UMINUS factor ) | power )
            int alt7=3;
            switch ( input.LA(1) ) {
            case PLUS:
                {
                alt7=1;
                }
                break;
            case MINUS:
                {
                alt7=2;
                }
                break;
            case ID:
            case LPAR:
            case DOUBLE:
            case PI:
            case E:
                {
                alt7=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("73:1: factor : ( PLUS factor -> ^( UPLUS factor ) | MINUS factor -> ^( UMINUS factor ) | power );", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // Cminus.g:74:7: PLUS factor
                    {
                    PLUS47=(Token)input.LT(1);
                    match(input,PLUS,FOLLOW_PLUS_in_factor501); 
                    stream_PLUS.add(PLUS47);

                    pushFollow(FOLLOW_factor_in_factor503);
                    factor48=factor();
                    _fsp--;

                    stream_factor.add(factor48.getTree());

                    // AST REWRITE
                    // elements: factor
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 74:19: -> ^( UPLUS factor )
                    {
                        // Cminus.g:74:22: ^( UPLUS factor )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(adaptor.create(UPLUS, "UPLUS"), root_1);

                        adaptor.addChild(root_1, stream_factor.next());

                        adaptor.addChild(root_0, root_1);
                        }

                    }



                    }
                    break;
                case 2 :
                    // Cminus.g:75:7: MINUS factor
                    {
                    MINUS49=(Token)input.LT(1);
                    match(input,MINUS,FOLLOW_MINUS_in_factor519); 
                    stream_MINUS.add(MINUS49);

                    pushFollow(FOLLOW_factor_in_factor521);
                    factor50=factor();
                    _fsp--;

                    stream_factor.add(factor50.getTree());

                    // AST REWRITE
                    // elements: factor
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 75:20: -> ^( UMINUS factor )
                    {
                        // Cminus.g:75:23: ^( UMINUS factor )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(adaptor.create(UMINUS, "UMINUS"), root_1);

                        adaptor.addChild(root_1, stream_factor.next());

                        adaptor.addChild(root_0, root_1);
                        }

                    }



                    }
                    break;
                case 3 :
                    // Cminus.g:76:7: power
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_power_in_factor537);
                    power51=power();
                    _fsp--;

                    adaptor.addChild(root_0, power51.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end factor

    public static class power_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start power
    // Cminus.g:79:1: power : atom ( POW f= factor )? ;
    public final power_return power() throws RecognitionException {
        power_return retval = new power_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token POW53=null;
        factor_return f = null;

        atom_return atom52 = null;


        Object POW53_tree=null;

        try {
            // Cminus.g:80:5: ( atom ( POW f= factor )? )
            // Cminus.g:80:7: atom ( POW f= factor )?
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_atom_in_power554);
            atom52=atom();
            _fsp--;

            adaptor.addChild(root_0, atom52.getTree());
            // Cminus.g:80:12: ( POW f= factor )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==POW) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // Cminus.g:80:13: POW f= factor
                    {
                    POW53=(Token)input.LT(1);
                    match(input,POW,FOLLOW_POW_in_power557); 
                    POW53_tree = (Object)adaptor.create(POW53);
                    root_0 = (Object)adaptor.becomeRoot(POW53_tree, root_0);

                    pushFollow(FOLLOW_factor_in_power562);
                    f=factor();
                    _fsp--;

                    adaptor.addChild(root_0, f.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end power

    public static class atom_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start atom
    // Cminus.g:83:1: atom : ( ID | DOUBLE | PI | E | LPAR expr RPAR -> ^( expr ) );
    public final atom_return atom() throws RecognitionException {
        atom_return retval = new atom_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ID54=null;
        Token DOUBLE55=null;
        Token PI56=null;
        Token E57=null;
        Token LPAR58=null;
        Token RPAR60=null;
        expr_return expr59 = null;


        Object ID54_tree=null;
        Object DOUBLE55_tree=null;
        Object PI56_tree=null;
        Object E57_tree=null;
        Object LPAR58_tree=null;
        Object RPAR60_tree=null;
        RewriteRuleTokenStream stream_RPAR=new RewriteRuleTokenStream(adaptor,"token RPAR");
        RewriteRuleTokenStream stream_LPAR=new RewriteRuleTokenStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // Cminus.g:84:5: ( ID | DOUBLE | PI | E | LPAR expr RPAR -> ^( expr ) )
            int alt9=5;
            switch ( input.LA(1) ) {
            case ID:
                {
                alt9=1;
                }
                break;
            case DOUBLE:
                {
                alt9=2;
                }
                break;
            case PI:
                {
                alt9=3;
                }
                break;
            case E:
                {
                alt9=4;
                }
                break;
            case LPAR:
                {
                alt9=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("83:1: atom : ( ID | DOUBLE | PI | E | LPAR expr RPAR -> ^( expr ) );", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // Cminus.g:84:7: ID
                    {
                    root_0 = (Object)adaptor.nil();

                    ID54=(Token)input.LT(1);
                    match(input,ID,FOLLOW_ID_in_atom585); 
                    ID54_tree = (Object)adaptor.create(ID54);
                    adaptor.addChild(root_0, ID54_tree);


                    }
                    break;
                case 2 :
                    // Cminus.g:85:7: DOUBLE
                    {
                    root_0 = (Object)adaptor.nil();

                    DOUBLE55=(Token)input.LT(1);
                    match(input,DOUBLE,FOLLOW_DOUBLE_in_atom593); 
                    DOUBLE55_tree = (Object)adaptor.create(DOUBLE55);
                    adaptor.addChild(root_0, DOUBLE55_tree);


                    }
                    break;
                case 3 :
                    // Cminus.g:86:7: PI
                    {
                    root_0 = (Object)adaptor.nil();

                    PI56=(Token)input.LT(1);
                    match(input,PI,FOLLOW_PI_in_atom601); 
                    PI56_tree = (Object)adaptor.create(PI56);
                    adaptor.addChild(root_0, PI56_tree);


                    }
                    break;
                case 4 :
                    // Cminus.g:87:7: E
                    {
                    root_0 = (Object)adaptor.nil();

                    E57=(Token)input.LT(1);
                    match(input,E,FOLLOW_E_in_atom609); 
                    E57_tree = (Object)adaptor.create(E57);
                    adaptor.addChild(root_0, E57_tree);


                    }
                    break;
                case 5 :
                    // Cminus.g:88:7: LPAR expr RPAR
                    {
                    LPAR58=(Token)input.LT(1);
                    match(input,LPAR,FOLLOW_LPAR_in_atom617); 
                    stream_LPAR.add(LPAR58);

                    pushFollow(FOLLOW_expr_in_atom619);
                    expr59=expr();
                    _fsp--;

                    stream_expr.add(expr59.getTree());
                    RPAR60=(Token)input.LT(1);
                    match(input,RPAR,FOLLOW_RPAR_in_atom621); 
                    stream_RPAR.add(RPAR60);


                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"token retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 88:22: -> ^( expr )
                    {
                        // Cminus.g:88:25: ^( expr )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(stream_expr.nextNode(), root_1);

                        adaptor.addChild(root_0, root_1);
                        }

                    }



                    }
                    break;

            }
            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end atom


 

    public static final BitSet FOLLOW_statements_in_program77 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_program79 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_statements102 = new BitSet(new long[]{0x0000000000239802L});
    public static final BitSet FOLLOW_declaration_in_statement121 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_DELIM_in_statement123 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assingment_in_statement132 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_DELIM_in_statement134 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_print_in_statement143 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_DELIM_in_statement145 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_input_in_statement154 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_DELIM_in_statement156 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifnt_in_statement165 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_whilent_in_statement173 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_declaration190 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_ID_in_declaration192 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_declaration195 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_ID_in_declaration197 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_ID_in_assingment225 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_EQ_in_assingment227 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_expr_in_assingment229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PRINT_in_print256 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_expr_in_print259 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INPUT_in_input276 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_ID_in_input279 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_ifnt296 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_LPAR_in_ifnt299 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_condition_in_ifnt302 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_RPAR_in_ifnt304 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_block_in_ifnt307 = new BitSet(new long[]{0x0000000000100002L});
    public static final BitSet FOLLOW_ELSE_in_ifnt310 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_block_in_ifnt313 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHILE_in_whilent332 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_LPAR_in_whilent335 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_condition_in_whilent338 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_RPAR_in_whilent340 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_block_in_whilent343 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBR_in_block360 = new BitSet(new long[]{0x0000000000239800L});
    public static final BitSet FOLLOW_statements_in_block362 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_RBR_in_block364 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_condition389 = new BitSet(new long[]{0x0000000003004000L});
    public static final BitSet FOLLOW_set_in_condition391 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_expr_in_condition404 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_term_in_expr423 = new BitSet(new long[]{0x000000000C000002L});
    public static final BitSet FOLLOW_PLUS_in_expr426 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_term_in_expr431 = new BitSet(new long[]{0x000000000C000002L});
    public static final BitSet FOLLOW_MINUS_in_expr435 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_term_in_expr440 = new BitSet(new long[]{0x000000000C000002L});
    public static final BitSet FOLLOW_factor_in_term461 = new BitSet(new long[]{0x0000000030000002L});
    public static final BitSet FOLLOW_MULT_in_term464 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_factor_in_term469 = new BitSet(new long[]{0x0000000030000002L});
    public static final BitSet FOLLOW_DIV_in_term473 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_factor_in_term478 = new BitSet(new long[]{0x0000000030000002L});
    public static final BitSet FOLLOW_PLUS_in_factor501 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_factor_in_factor503 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_factor519 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_factor_in_factor521 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_power_in_factor537 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atom_in_power554 = new BitSet(new long[]{0x0000000040000002L});
    public static final BitSet FOLLOW_POW_in_power557 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_factor_in_power562 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom585 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOUBLE_in_atom593 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PI_in_atom601 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_E_in_atom609 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_atom617 = new BitSet(new long[]{0x000000038C041000L});
    public static final BitSet FOLLOW_expr_in_atom619 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_RPAR_in_atom621 = new BitSet(new long[]{0x0000000000000002L});

}