lexer grammar Cminus;

// $ANTLR src "Cminus.g" 91
VAR
    : 'var'
    ;

// $ANTLR src "Cminus.g" 95
IF
    : 'if'
    ;

// $ANTLR src "Cminus.g" 99
ELSE
    : 'else'
    ;

// $ANTLR src "Cminus.g" 103
PRINT
    : 'print'
    ;

// $ANTLR src "Cminus.g" 107
INPUT
    : 'input'
    ;

// $ANTLR src "Cminus.g" 111
WHILE
    : 'while'
    ;

// $ANTLR src "Cminus.g" 115
PI
    : 'PI'
    ;

// $ANTLR src "Cminus.g" 119
E
    : 'E'
    ;

// $ANTLR src "Cminus.g" 123
ID
    : LETTER (LETTER | INT)*
    ;

// $ANTLR src "Cminus.g" 127
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "Cminus.g" 132
DOUBLE
    : INT
    | '.' INT
    | INT '.'
    | INT '.' INT
    ;

// $ANTLR src "Cminus.g" 139
fragment INT
    : '0'..'9'+
    ;

// $ANTLR src "Cminus.g" 143
PLUS
    : '+'
    ;
    
// $ANTLR src "Cminus.g" 147
MINUS
    : '-'
    ;
    
// $ANTLR src "Cminus.g" 151
MULT
    : '*'
    ;
    
// $ANTLR src "Cminus.g" 155
DIV
    : '/'
    ;
    
// $ANTLR src "Cminus.g" 159
POW
    : '**'
    ;

// $ANTLR src "Cminus.g" 163
LPAR
    : '('
    ;

// $ANTLR src "Cminus.g" 167
RPAR
    : ')'
    ;

// $ANTLR src "Cminus.g" 171
LBR
    : '{'
    ;

// $ANTLR src "Cminus.g" 175
RBR
    : '}'
    ;

// $ANTLR src "Cminus.g" 179
DELIM
    : ';'
    ;

// $ANTLR src "Cminus.g" 183
COMMA
    : ','
    ;

// $ANTLR src "Cminus.g" 187
EQ
    : '='
    ;

// $ANTLR src "Cminus.g" 191
LT
    : '<'
    ;

// $ANTLR src "Cminus.g" 195
GT
    : '>'
    ;

// $ANTLR src "Cminus.g" 199
WHITESPACE
    : ('\t'|' '|'\r'|'\n'|'\u000C')+ {$channel = HIDDEN;}
    ;

// $ANTLR src "Cminus.g" 203
COMMENT
    : '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
    | '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
    ;

