// $ANTLR 3.2 Sep 23, 2009 12:02:23 /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g 2010-03-24 10:42:31

import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.runtime.debug.*;
import java.io.IOException;

import org.antlr.runtime.tree.*;

public class CminusParser extends DebugParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VARDEF", "ASSIGN", "COMPARE", "DELIM", "VAR", "ID", "COMMA", "EQ", "LBR", "RBR", "LT", "GT", "PLUS", "MINUS", "MULT", "DIV", "POW", "DOUBLE", "PI", "E", "LPAR", "RPAR", "IF", "ELSE", "LETTER", "INT", "WHITESPACE"
    };
    public static final int E=23;
    public static final int LT=14;
    public static final int LETTER=28;
    public static final int RBR=13;
    public static final int ELSE=27;
    public static final int WHITESPACE=30;
    public static final int INT=29;
    public static final int MINUS=17;
    public static final int MULT=18;
    public static final int DELIM=7;
    public static final int ID=9;
    public static final int EOF=-1;
    public static final int LBR=12;
    public static final int IF=26;
    public static final int POW=20;
    public static final int LPAR=24;
    public static final int COMMA=10;
    public static final int ASSIGN=5;
    public static final int COMPARE=6;
    public static final int DOUBLE=21;
    public static final int GT=15;
    public static final int RPAR=25;
    public static final int PLUS=16;
    public static final int VAR=8;
    public static final int PI=22;
    public static final int EQ=11;
    public static final int DIV=19;
    public static final int VARDEF=4;

    // delegates
    // delegators

    public static final String[] ruleNames = new String[] {
        "invalidRule", "program", "atom", "term", "declaration", "expr", 
        "condition", "factor", "statements", "power", "statement", "block", 
        "assingment"
    };
     
        public int ruleLevel = 0;
        public int getRuleLevel() { return ruleLevel; }
        public void incRuleLevel() { ruleLevel++; }
        public void decRuleLevel() { ruleLevel--; }
        public CminusParser(TokenStream input) {
            this(input, DebugEventSocketProxy.DEFAULT_DEBUGGER_PORT, new RecognizerSharedState());
        }
        public CminusParser(TokenStream input, int port, RecognizerSharedState state) {
            super(input, state);
            DebugEventSocketProxy proxy =
                new DebugEventSocketProxy(this,port,adaptor);
            setDebugListener(proxy);
            setTokenStream(new DebugTokenStream(input,proxy));
            try {
                proxy.handshake();
            }
            catch (IOException ioe) {
                reportError(ioe);
            }
            TreeAdaptor adap = new CommonTreeAdaptor();
            setTreeAdaptor(adap);
            proxy.setTreeAdaptor(adap);
        }
    public CminusParser(TokenStream input, DebugEventListener dbg) {
        super(input, dbg);

         
        TreeAdaptor adap = new CommonTreeAdaptor();
        setTreeAdaptor(adap);

    }
    protected boolean evalPredicate(boolean result, String predicate) {
        dbg.semanticPredicate(result, predicate);
        return result;
    }

    protected DebugTreeAdaptor adaptor;
    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = new DebugTreeAdaptor(dbg,adaptor);

    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }


    public String[] getTokenNames() { return CminusParser.tokenNames; }
    public String getGrammarFileName() { return "/home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g"; }


    public static class program_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "program"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:13:1: program : statements EOF ;
    public final CminusParser.program_return program() throws RecognitionException {
        CminusParser.program_return retval = new CminusParser.program_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EOF2=null;
        CminusParser.statements_return statements1 = null;


        Object EOF2_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "program");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(13, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:14:5: ( statements EOF )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:14:7: statements EOF
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(14,7);
            pushFollow(FOLLOW_statements_in_program56);
            statements1=statements();

            state._fsp--;

            adaptor.addChild(root_0, statements1.getTree());
            dbg.location(14,21);
            EOF2=(Token)match(input,EOF,FOLLOW_EOF_in_program58); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(15, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "program");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "program"

    public static class statements_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "statements"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:17:1: statements : ( statement )+ ;
    public final CminusParser.statements_return statements() throws RecognitionException {
        CminusParser.statements_return retval = new CminusParser.statements_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        CminusParser.statement_return statement3 = null;



        try { dbg.enterRule(getGrammarFileName(), "statements");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(17, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:18:5: ( ( statement )+ )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:18:7: ( statement )+
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(18,7);
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:18:7: ( statement )+
            int cnt1=0;
            try { dbg.enterSubRule(1);

            loop1:
            do {
                int alt1=2;
                try { dbg.enterDecision(1);

                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=VAR && LA1_0<=ID)) ) {
                    alt1=1;
                }


                } finally {dbg.exitDecision(1);}

                switch (alt1) {
            	case 1 :
            	    dbg.enterAlt(1);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:18:8: statement
            	    {
            	    dbg.location(18,8);
            	    pushFollow(FOLLOW_statement_in_statements81);
            	    statement3=statement();

            	    state._fsp--;

            	    adaptor.addChild(root_0, statement3.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        dbg.recognitionException(eee);

                        throw eee;
                }
                cnt1++;
            } while (true);
            } finally {dbg.exitSubRule(1);}


            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(19, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "statements");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "statements"

    public static class statement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "statement"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:21:1: statement : ( declaration DELIM | assingment DELIM );
    public final CminusParser.statement_return statement() throws RecognitionException {
        CminusParser.statement_return retval = new CminusParser.statement_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token DELIM5=null;
        Token DELIM7=null;
        CminusParser.declaration_return declaration4 = null;

        CminusParser.assingment_return assingment6 = null;


        Object DELIM5_tree=null;
        Object DELIM7_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "statement");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(21, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:22:5: ( declaration DELIM | assingment DELIM )
            int alt2=2;
            try { dbg.enterDecision(2);

            int LA2_0 = input.LA(1);

            if ( (LA2_0==VAR) ) {
                alt2=1;
            }
            else if ( (LA2_0==ID) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                dbg.recognitionException(nvae);
                throw nvae;
            }
            } finally {dbg.exitDecision(2);}

            switch (alt2) {
                case 1 :
                    dbg.enterAlt(1);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:22:7: declaration DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(22,7);
                    pushFollow(FOLLOW_declaration_in_statement100);
                    declaration4=declaration();

                    state._fsp--;

                    adaptor.addChild(root_0, declaration4.getTree());
                    dbg.location(22,24);
                    DELIM5=(Token)match(input,DELIM,FOLLOW_DELIM_in_statement102); 

                    }
                    break;
                case 2 :
                    dbg.enterAlt(2);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:23:7: assingment DELIM
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(23,7);
                    pushFollow(FOLLOW_assingment_in_statement111);
                    assingment6=assingment();

                    state._fsp--;

                    adaptor.addChild(root_0, assingment6.getTree());
                    dbg.location(23,23);
                    DELIM7=(Token)match(input,DELIM,FOLLOW_DELIM_in_statement113); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(25, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "statement");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "statement"

    public static class declaration_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declaration"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:27:1: declaration : VAR ID ( COMMA ID )* -> ( ^( VARDEF ID ) )+ ;
    public final CminusParser.declaration_return declaration() throws RecognitionException {
        CminusParser.declaration_return retval = new CminusParser.declaration_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token VAR8=null;
        Token ID9=null;
        Token COMMA10=null;
        Token ID11=null;

        Object VAR8_tree=null;
        Object ID9_tree=null;
        Object COMMA10_tree=null;
        Object ID11_tree=null;
        RewriteRuleTokenStream stream_VAR=new RewriteRuleTokenStream(adaptor,"token VAR");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");

        try { dbg.enterRule(getGrammarFileName(), "declaration");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(27, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:28:5: ( VAR ID ( COMMA ID )* -> ( ^( VARDEF ID ) )+ )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:28:7: VAR ID ( COMMA ID )*
            {
            dbg.location(28,7);
            VAR8=(Token)match(input,VAR,FOLLOW_VAR_in_declaration132);  
            stream_VAR.add(VAR8);

            dbg.location(28,11);
            ID9=(Token)match(input,ID,FOLLOW_ID_in_declaration134);  
            stream_ID.add(ID9);

            dbg.location(28,14);
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:28:14: ( COMMA ID )*
            try { dbg.enterSubRule(3);

            loop3:
            do {
                int alt3=2;
                try { dbg.enterDecision(3);

                int LA3_0 = input.LA(1);

                if ( (LA3_0==COMMA) ) {
                    alt3=1;
                }


                } finally {dbg.exitDecision(3);}

                switch (alt3) {
            	case 1 :
            	    dbg.enterAlt(1);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:28:15: COMMA ID
            	    {
            	    dbg.location(28,15);
            	    COMMA10=(Token)match(input,COMMA,FOLLOW_COMMA_in_declaration137);  
            	    stream_COMMA.add(COMMA10);

            	    dbg.location(28,21);
            	    ID11=(Token)match(input,ID,FOLLOW_ID_in_declaration139);  
            	    stream_ID.add(ID11);


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);
            } finally {dbg.exitSubRule(3);}



            // AST REWRITE
            // elements: ID
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 28:26: -> ( ^( VARDEF ID ) )+
            {
                dbg.location(28,29);
                if ( !(stream_ID.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_ID.hasNext() ) {
                    dbg.location(28,29);
                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:28:29: ^( VARDEF ID )
                    {
                    Object root_1 = (Object)adaptor.nil();
                    dbg.location(28,31);
                    root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARDEF, "VARDEF"), root_1);

                    dbg.location(28,38);
                    adaptor.addChild(root_1, stream_ID.nextNode());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_ID.reset();

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(29, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "declaration");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "declaration"

    public static class assingment_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "assingment"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:31:1: assingment : ID EQ expr -> ^( ASSIGN ID expr ) ;
    public final CminusParser.assingment_return assingment() throws RecognitionException {
        CminusParser.assingment_return retval = new CminusParser.assingment_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ID12=null;
        Token EQ13=null;
        CminusParser.expr_return expr14 = null;


        Object ID12_tree=null;
        Object EQ13_tree=null;
        RewriteRuleTokenStream stream_EQ=new RewriteRuleTokenStream(adaptor,"token EQ");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try { dbg.enterRule(getGrammarFileName(), "assingment");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(31, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:32:5: ( ID EQ expr -> ^( ASSIGN ID expr ) )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:32:7: ID EQ expr
            {
            dbg.location(32,7);
            ID12=(Token)match(input,ID,FOLLOW_ID_in_assingment167);  
            stream_ID.add(ID12);

            dbg.location(32,10);
            EQ13=(Token)match(input,EQ,FOLLOW_EQ_in_assingment169);  
            stream_EQ.add(EQ13);

            dbg.location(32,13);
            pushFollow(FOLLOW_expr_in_assingment171);
            expr14=expr();

            state._fsp--;

            stream_expr.add(expr14.getTree());


            // AST REWRITE
            // elements: expr, ID
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 32:18: -> ^( ASSIGN ID expr )
            {
                dbg.location(32,21);
                // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:32:21: ^( ASSIGN ID expr )
                {
                Object root_1 = (Object)adaptor.nil();
                dbg.location(32,23);
                root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ASSIGN, "ASSIGN"), root_1);

                dbg.location(32,30);
                adaptor.addChild(root_1, stream_ID.nextNode());
                dbg.location(32,33);
                adaptor.addChild(root_1, stream_expr.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(33, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "assingment");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "assingment"

    public static class block_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "block"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:39:1: block : LBR statements RBR ;
    public final CminusParser.block_return block() throws RecognitionException {
        CminusParser.block_return retval = new CminusParser.block_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBR15=null;
        Token RBR17=null;
        CminusParser.statements_return statements16 = null;


        Object LBR15_tree=null;
        Object RBR17_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "block");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(39, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:40:5: ( LBR statements RBR )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:40:7: LBR statements RBR
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(40,10);
            LBR15=(Token)match(input,LBR,FOLLOW_LBR_in_block202); 
            dbg.location(40,12);
            pushFollow(FOLLOW_statements_in_block205);
            statements16=statements();

            state._fsp--;

            adaptor.addChild(root_0, statements16.getTree());
            dbg.location(40,26);
            RBR17=(Token)match(input,RBR,FOLLOW_RBR_in_block207); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(41, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "block");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "block"

    public static class condition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "condition"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:43:1: condition : expr ( LT | EQ | GT ) expr ;
    public final CminusParser.condition_return condition() throws RecognitionException {
        CminusParser.condition_return retval = new CminusParser.condition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set19=null;
        CminusParser.expr_return expr18 = null;

        CminusParser.expr_return expr20 = null;


        Object set19_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "condition");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(43, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:44:5: ( expr ( LT | EQ | GT ) expr )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:44:7: expr ( LT | EQ | GT ) expr
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(44,7);
            pushFollow(FOLLOW_expr_in_condition225);
            expr18=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr18.getTree());
            dbg.location(44,12);
            set19=(Token)input.LT(1);
            set19=(Token)input.LT(1);
            if ( input.LA(1)==EQ||(input.LA(1)>=LT && input.LA(1)<=GT) ) {
                input.consume();
                root_0 = (Object)adaptor.becomeRoot((Object)adaptor.create(set19), root_0);
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                dbg.recognitionException(mse);
                throw mse;
            }

            dbg.location(44,28);
            pushFollow(FOLLOW_expr_in_condition240);
            expr20=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr20.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(45, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "condition");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "condition"

    public static class expr_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:47:1: expr : t1= term ( PLUS t2= term | MINUS t2= term )* ;
    public final CminusParser.expr_return expr() throws RecognitionException {
        CminusParser.expr_return retval = new CminusParser.expr_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token PLUS21=null;
        Token MINUS22=null;
        CminusParser.term_return t1 = null;

        CminusParser.term_return t2 = null;


        Object PLUS21_tree=null;
        Object MINUS22_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "expr");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(47, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:48:5: (t1= term ( PLUS t2= term | MINUS t2= term )* )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:48:7: t1= term ( PLUS t2= term | MINUS t2= term )*
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(48,9);
            pushFollow(FOLLOW_term_in_expr259);
            t1=term();

            state._fsp--;

            adaptor.addChild(root_0, t1.getTree());
            dbg.location(48,15);
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:48:15: ( PLUS t2= term | MINUS t2= term )*
            try { dbg.enterSubRule(4);

            loop4:
            do {
                int alt4=3;
                try { dbg.enterDecision(4);

                int LA4_0 = input.LA(1);

                if ( (LA4_0==PLUS) ) {
                    alt4=1;
                }
                else if ( (LA4_0==MINUS) ) {
                    alt4=2;
                }


                } finally {dbg.exitDecision(4);}

                switch (alt4) {
            	case 1 :
            	    dbg.enterAlt(1);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:48:16: PLUS t2= term
            	    {
            	    dbg.location(48,20);
            	    PLUS21=(Token)match(input,PLUS,FOLLOW_PLUS_in_expr262); 
            	    PLUS21_tree = (Object)adaptor.create(PLUS21);
            	    root_0 = (Object)adaptor.becomeRoot(PLUS21_tree, root_0);

            	    dbg.location(48,24);
            	    pushFollow(FOLLOW_term_in_expr267);
            	    t2=term();

            	    state._fsp--;

            	    adaptor.addChild(root_0, t2.getTree());

            	    }
            	    break;
            	case 2 :
            	    dbg.enterAlt(2);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:48:32: MINUS t2= term
            	    {
            	    dbg.location(48,37);
            	    MINUS22=(Token)match(input,MINUS,FOLLOW_MINUS_in_expr271); 
            	    MINUS22_tree = (Object)adaptor.create(MINUS22);
            	    root_0 = (Object)adaptor.becomeRoot(MINUS22_tree, root_0);

            	    dbg.location(48,41);
            	    pushFollow(FOLLOW_term_in_expr276);
            	    t2=term();

            	    state._fsp--;

            	    adaptor.addChild(root_0, t2.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);
            } finally {dbg.exitSubRule(4);}


            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(49, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "expr");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "expr"

    public static class term_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "term"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:51:1: term : f1= factor ( MULT f2= factor | DIV f2= factor )* ;
    public final CminusParser.term_return term() throws RecognitionException {
        CminusParser.term_return retval = new CminusParser.term_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token MULT23=null;
        Token DIV24=null;
        CminusParser.factor_return f1 = null;

        CminusParser.factor_return f2 = null;


        Object MULT23_tree=null;
        Object DIV24_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "term");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(51, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:52:5: (f1= factor ( MULT f2= factor | DIV f2= factor )* )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:52:7: f1= factor ( MULT f2= factor | DIV f2= factor )*
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(52,9);
            pushFollow(FOLLOW_factor_in_term297);
            f1=factor();

            state._fsp--;

            adaptor.addChild(root_0, f1.getTree());
            dbg.location(52,17);
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:52:17: ( MULT f2= factor | DIV f2= factor )*
            try { dbg.enterSubRule(5);

            loop5:
            do {
                int alt5=3;
                try { dbg.enterDecision(5);

                int LA5_0 = input.LA(1);

                if ( (LA5_0==MULT) ) {
                    alt5=1;
                }
                else if ( (LA5_0==DIV) ) {
                    alt5=2;
                }


                } finally {dbg.exitDecision(5);}

                switch (alt5) {
            	case 1 :
            	    dbg.enterAlt(1);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:52:18: MULT f2= factor
            	    {
            	    dbg.location(52,22);
            	    MULT23=(Token)match(input,MULT,FOLLOW_MULT_in_term300); 
            	    MULT23_tree = (Object)adaptor.create(MULT23);
            	    root_0 = (Object)adaptor.becomeRoot(MULT23_tree, root_0);

            	    dbg.location(52,26);
            	    pushFollow(FOLLOW_factor_in_term305);
            	    f2=factor();

            	    state._fsp--;

            	    adaptor.addChild(root_0, f2.getTree());

            	    }
            	    break;
            	case 2 :
            	    dbg.enterAlt(2);

            	    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:52:36: DIV f2= factor
            	    {
            	    dbg.location(52,39);
            	    DIV24=(Token)match(input,DIV,FOLLOW_DIV_in_term309); 
            	    DIV24_tree = (Object)adaptor.create(DIV24);
            	    root_0 = (Object)adaptor.becomeRoot(DIV24_tree, root_0);

            	    dbg.location(52,43);
            	    pushFollow(FOLLOW_factor_in_term314);
            	    f2=factor();

            	    state._fsp--;

            	    adaptor.addChild(root_0, f2.getTree());

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);
            } finally {dbg.exitSubRule(5);}


            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(53, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "term");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "term"

    public static class factor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "factor"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:55:1: factor : ( PLUS f1= factor | MINUS f2= factor | power );
    public final CminusParser.factor_return factor() throws RecognitionException {
        CminusParser.factor_return retval = new CminusParser.factor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token PLUS25=null;
        Token MINUS26=null;
        CminusParser.factor_return f1 = null;

        CminusParser.factor_return f2 = null;

        CminusParser.power_return power27 = null;


        Object PLUS25_tree=null;
        Object MINUS26_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "factor");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(55, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:56:5: ( PLUS f1= factor | MINUS f2= factor | power )
            int alt6=3;
            try { dbg.enterDecision(6);

            switch ( input.LA(1) ) {
            case PLUS:
                {
                alt6=1;
                }
                break;
            case MINUS:
                {
                alt6=2;
                }
                break;
            case ID:
            case DOUBLE:
            case PI:
            case E:
            case LPAR:
                {
                alt6=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                dbg.recognitionException(nvae);
                throw nvae;
            }

            } finally {dbg.exitDecision(6);}

            switch (alt6) {
                case 1 :
                    dbg.enterAlt(1);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:56:7: PLUS f1= factor
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(56,11);
                    PLUS25=(Token)match(input,PLUS,FOLLOW_PLUS_in_factor337); 
                    PLUS25_tree = (Object)adaptor.create(PLUS25);
                    root_0 = (Object)adaptor.becomeRoot(PLUS25_tree, root_0);

                    dbg.location(56,15);
                    pushFollow(FOLLOW_factor_in_factor342);
                    f1=factor();

                    state._fsp--;

                    adaptor.addChild(root_0, f1.getTree());

                    }
                    break;
                case 2 :
                    dbg.enterAlt(2);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:57:7: MINUS f2= factor
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(57,12);
                    MINUS26=(Token)match(input,MINUS,FOLLOW_MINUS_in_factor350); 
                    MINUS26_tree = (Object)adaptor.create(MINUS26);
                    root_0 = (Object)adaptor.becomeRoot(MINUS26_tree, root_0);

                    dbg.location(57,16);
                    pushFollow(FOLLOW_factor_in_factor355);
                    f2=factor();

                    state._fsp--;

                    adaptor.addChild(root_0, f2.getTree());

                    }
                    break;
                case 3 :
                    dbg.enterAlt(3);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:58:7: power
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(58,7);
                    pushFollow(FOLLOW_power_in_factor363);
                    power27=power();

                    state._fsp--;

                    adaptor.addChild(root_0, power27.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(59, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "factor");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "factor"

    public static class power_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "power"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:61:1: power : atom ( POW f= factor )? ;
    public final CminusParser.power_return power() throws RecognitionException {
        CminusParser.power_return retval = new CminusParser.power_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token POW29=null;
        CminusParser.factor_return f = null;

        CminusParser.atom_return atom28 = null;


        Object POW29_tree=null;

        try { dbg.enterRule(getGrammarFileName(), "power");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(61, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:62:5: ( atom ( POW f= factor )? )
            dbg.enterAlt(1);

            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:62:7: atom ( POW f= factor )?
            {
            root_0 = (Object)adaptor.nil();

            dbg.location(62,7);
            pushFollow(FOLLOW_atom_in_power380);
            atom28=atom();

            state._fsp--;

            adaptor.addChild(root_0, atom28.getTree());
            dbg.location(62,12);
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:62:12: ( POW f= factor )?
            int alt7=2;
            try { dbg.enterSubRule(7);
            try { dbg.enterDecision(7);

            int LA7_0 = input.LA(1);

            if ( (LA7_0==POW) ) {
                alt7=1;
            }
            } finally {dbg.exitDecision(7);}

            switch (alt7) {
                case 1 :
                    dbg.enterAlt(1);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:62:13: POW f= factor
                    {
                    dbg.location(62,16);
                    POW29=(Token)match(input,POW,FOLLOW_POW_in_power383); 
                    POW29_tree = (Object)adaptor.create(POW29);
                    root_0 = (Object)adaptor.becomeRoot(POW29_tree, root_0);

                    dbg.location(62,19);
                    pushFollow(FOLLOW_factor_in_power388);
                    f=factor();

                    state._fsp--;

                    adaptor.addChild(root_0, f.getTree());

                    }
                    break;

            }
            } finally {dbg.exitSubRule(7);}


            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(63, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "power");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "power"

    public static class atom_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atom"
    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:65:1: atom : ( ID | DOUBLE | PI | E | LPAR expr RPAR -> ^( expr ) );
    public final CminusParser.atom_return atom() throws RecognitionException {
        CminusParser.atom_return retval = new CminusParser.atom_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ID30=null;
        Token DOUBLE31=null;
        Token PI32=null;
        Token E33=null;
        Token LPAR34=null;
        Token RPAR36=null;
        CminusParser.expr_return expr35 = null;


        Object ID30_tree=null;
        Object DOUBLE31_tree=null;
        Object PI32_tree=null;
        Object E33_tree=null;
        Object LPAR34_tree=null;
        Object RPAR36_tree=null;
        RewriteRuleTokenStream stream_RPAR=new RewriteRuleTokenStream(adaptor,"token RPAR");
        RewriteRuleTokenStream stream_LPAR=new RewriteRuleTokenStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try { dbg.enterRule(getGrammarFileName(), "atom");
        if ( getRuleLevel()==0 ) {dbg.commence();}
        incRuleLevel();
        dbg.location(65, 1);

        try {
            // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:66:5: ( ID | DOUBLE | PI | E | LPAR expr RPAR -> ^( expr ) )
            int alt8=5;
            try { dbg.enterDecision(8);

            switch ( input.LA(1) ) {
            case ID:
                {
                alt8=1;
                }
                break;
            case DOUBLE:
                {
                alt8=2;
                }
                break;
            case PI:
                {
                alt8=3;
                }
                break;
            case E:
                {
                alt8=4;
                }
                break;
            case LPAR:
                {
                alt8=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                dbg.recognitionException(nvae);
                throw nvae;
            }

            } finally {dbg.exitDecision(8);}

            switch (alt8) {
                case 1 :
                    dbg.enterAlt(1);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:66:7: ID
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(66,7);
                    ID30=(Token)match(input,ID,FOLLOW_ID_in_atom411); 
                    ID30_tree = (Object)adaptor.create(ID30);
                    adaptor.addChild(root_0, ID30_tree);


                    }
                    break;
                case 2 :
                    dbg.enterAlt(2);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:67:7: DOUBLE
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(67,7);
                    DOUBLE31=(Token)match(input,DOUBLE,FOLLOW_DOUBLE_in_atom419); 
                    DOUBLE31_tree = (Object)adaptor.create(DOUBLE31);
                    adaptor.addChild(root_0, DOUBLE31_tree);


                    }
                    break;
                case 3 :
                    dbg.enterAlt(3);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:68:7: PI
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(68,7);
                    PI32=(Token)match(input,PI,FOLLOW_PI_in_atom427); 
                    PI32_tree = (Object)adaptor.create(PI32);
                    adaptor.addChild(root_0, PI32_tree);


                    }
                    break;
                case 4 :
                    dbg.enterAlt(4);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:69:7: E
                    {
                    root_0 = (Object)adaptor.nil();

                    dbg.location(69,7);
                    E33=(Token)match(input,E,FOLLOW_E_in_atom435); 
                    E33_tree = (Object)adaptor.create(E33);
                    adaptor.addChild(root_0, E33_tree);


                    }
                    break;
                case 5 :
                    dbg.enterAlt(5);

                    // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:70:7: LPAR expr RPAR
                    {
                    dbg.location(70,7);
                    LPAR34=(Token)match(input,LPAR,FOLLOW_LPAR_in_atom443);  
                    stream_LPAR.add(LPAR34);

                    dbg.location(70,12);
                    pushFollow(FOLLOW_expr_in_atom445);
                    expr35=expr();

                    state._fsp--;

                    stream_expr.add(expr35.getTree());
                    dbg.location(70,17);
                    RPAR36=(Token)match(input,RPAR,FOLLOW_RPAR_in_atom447);  
                    stream_RPAR.add(RPAR36);



                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 70:22: -> ^( expr )
                    {
                        dbg.location(70,25);
                        // /home/venrock/dev/work/USU/CC/samples/antlr/c-/Cminus.g:70:25: ^( expr )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        dbg.location(70,27);
                        root_1 = (Object)adaptor.becomeRoot(stream_expr.nextNode(), root_1);

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        dbg.location(71, 5);

        }
        finally {
            dbg.exitRule(getGrammarFileName(), "atom");
            decRuleLevel();
            if ( getRuleLevel()==0 ) {dbg.terminate();}
        }

        return retval;
    }
    // $ANTLR end "atom"

    // Delegated rules


 

    public static final BitSet FOLLOW_statements_in_program56 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_program58 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_statements81 = new BitSet(new long[]{0x0000000000000302L});
    public static final BitSet FOLLOW_declaration_in_statement100 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_DELIM_in_statement102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_assingment_in_statement111 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_DELIM_in_statement113 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_declaration132 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_ID_in_declaration134 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_declaration137 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_ID_in_declaration139 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_ID_in_assingment167 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_EQ_in_assingment169 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_expr_in_assingment171 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBR_in_block202 = new BitSet(new long[]{0x0000000000000300L});
    public static final BitSet FOLLOW_statements_in_block205 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_RBR_in_block207 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_condition225 = new BitSet(new long[]{0x000000000000C800L});
    public static final BitSet FOLLOW_set_in_condition227 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_expr_in_condition240 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_term_in_expr259 = new BitSet(new long[]{0x0000000000030002L});
    public static final BitSet FOLLOW_PLUS_in_expr262 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_term_in_expr267 = new BitSet(new long[]{0x0000000000030002L});
    public static final BitSet FOLLOW_MINUS_in_expr271 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_term_in_expr276 = new BitSet(new long[]{0x0000000000030002L});
    public static final BitSet FOLLOW_factor_in_term297 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_MULT_in_term300 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_factor_in_term305 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_DIV_in_term309 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_factor_in_term314 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_PLUS_in_factor337 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_factor_in_factor342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_factor350 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_factor_in_factor355 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_power_in_factor363 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atom_in_power380 = new BitSet(new long[]{0x0000000000100002L});
    public static final BitSet FOLLOW_POW_in_power383 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_factor_in_power388 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOUBLE_in_atom419 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PI_in_atom427 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_E_in_atom435 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_atom443 = new BitSet(new long[]{0x0000000001E30200L});
    public static final BitSet FOLLOW_expr_in_atom445 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_RPAR_in_atom447 = new BitSet(new long[]{0x0000000000000002L});

}